using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Security.Permissions;
using UnityEngine;
using TMPro;
using UnityEngine.Events;
using System.Threading;
namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),
                    NameOverride = "Retractable sword",
                    DescriptionOverride = "A cool pointy thing",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Rsword/RswordThumb.png"),
                    AfterSpawn = (Instance) =>
                   {
                       Instance.GetComponent<PhysicalBehaviour>().DisplayBloodDecals = true;
                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Rsword/Rswordoff.png");
                       Instance.FixColliders();
                       Instance.AddComponent(typeof(RswordBehaviour));
                       var Rsword = Instance.GetComponent<RswordBehaviour>();
                       Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                       AudioSource RswordAudio = Instance.AddComponent(typeof(AudioSource)) as AudioSource;
                       Rsword.audioclip = ModAPI.LoadSound("Sounds/Rsword/RswordSound.wav");
                       Rsword.audio = RswordAudio;

                       Instance.AddComponent<UseEventTrigger>().Action = () =>
                       {
                           Instance.FixColliders();
                       };
                       Rsword.A = ModAPI.LoadSprite("Textures/Rsword/Rswordoff.png");
                       Rsword.B = ModAPI.LoadSprite("Textures/Rsword/Rswordon.png");
                    }
                }
            );
            ModAPI.Register(
                   new Modification()
                   {
                       OriginalItem = ModAPI.FindSpawnable("Knife"),
                       NameOverride = "Pencil",
                       DescriptionOverride = "I once saw him kill 3 people... with a pencil.",
                       CategoryOverride = ModAPI.FindCategory("Melee"),
                       ThumbnailOverride = ModAPI.LoadSprite("Textures/Pencil/PencilThumb.png"),
                       AfterSpawn = (Instance) =>
                       {
                           var Number = Random.Range(1, 10); 
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pencil/" + Number + "Pencil.png", 3f);
                           Instance.FixColliders();
                       }
                   }
               );
            ModAPI.Register(
                   new Modification()
                   {
                       OriginalItem = ModAPI.FindSpawnable("Knife"),
                       NameOverride = "Pen",
                       DescriptionOverride = "Less cooler but still cool pointy thing.",
                       CategoryOverride = ModAPI.FindCategory("Melee"),
                       ThumbnailOverride = ModAPI.LoadSprite("Textures/Pen/PenThumb.png"),
                       AfterSpawn = (Instance) =>
                       {
                           var NumberA = Random.Range(1, 5);
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pen/Pen" + NumberA + "A.png", 3f);
                           Instance.FixColliders();
                           Instance.AddComponent(typeof(PenBehaviour));
                           var Pen = Instance.GetComponent<PenBehaviour>();
                           Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Objects";

                           var NumberB = Random.Range(1, 3);
                           AudioSource PenAudio = Instance.AddComponent(typeof(AudioSource)) as AudioSource;
                           Pen.audioclip = ModAPI.LoadSound("Sounds/Pen/PenSound" + NumberB + ".wav");
                           Pen.audio = PenAudio;

                           Instance.AddComponent<UseEventTrigger>().Action = () =>
                           {
                               Instance.FixColliders();
                           };
                           Pen.A = ModAPI.LoadSprite("Textures/Pen/Pen" + NumberA + "A.png", 3f);
                           Pen.B = ModAPI.LoadSprite("Textures/Pen/Pen" + NumberA + "B.png", 3f);
                       }
                   }
                );
            ModAPI.Register(
                   new Modification()
                    {
                       OriginalItem = ModAPI.FindSpawnable("Plank"),
                       NameOverride = "Fake hand",
                       DescriptionOverride = "A solution for amputees.",
                       CategoryOverride = ModAPI.FindCategory("Melee"),
                       ThumbnailOverride = ModAPI.LoadSprite("Textures/FakeLimbs/FakeHandThumb.png"),
                       AfterSpawn = (Instance) =>
                       {
                           var NumberA = Random.Range(1, 4);
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FakeLimbs/FakeHand"+NumberA+".png");
                           Instance.FixColliders();
                       }
                   }
               );
            ModAPI.Register(
                   new Modification()
                   {
                       OriginalItem = ModAPI.FindSpawnable("Plank"),
                       NameOverride = "Fake foot",
                       DescriptionOverride = "Another solution for amputees.",
                       CategoryOverride = ModAPI.FindCategory("Melee"),
                       ThumbnailOverride = ModAPI.LoadSprite("Textures/FakeLimbs/FakeFootThumb.png"),
                       AfterSpawn = (Instance) =>
                       {
                           var NumberA = Random.Range(1, 3);
                           Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FakeLimbs/FakeFoot" + NumberA + ".png");
                           Instance.FixColliders();
                       }
                   }
               );
        }
    }

    class RswordBehaviour : MonoBehaviour
    {
        private void Start()
        {
            physical = gameObject.GetComponent<PhysicalBehaviour>();
            renderer = gameObject.GetComponent<SpriteRenderer>();
            light = ModAPI.CreateLight(transform, Color.red, 1.8f, 0f);
            light.transform.localPosition = new Vector3(0, -.4f, 0);
            UpdateState();
        }
        void UpdateState()
        {
            if (Activated)
            {
                physical.DisplayBloodDecals = false;
                renderer.sprite = B;
                light.Brightness = 2f;
            }
            else
            {
                renderer.sprite = A;
                light.Brightness = 0f;
                physical.DisplayBloodDecals = true;
            }
        }
        private void Use()
        {
            if (!base.enabled)
            {
                return;
            }
            if (Activated)
            {
                audio.PlayOneShot(audioclip, 1f);
            }
            else
            {
                audio.PlayOneShot(audioclip, 1f);
            }

            SetActivated(!Activated);
        }
        private void SetActivated(bool activated)
        {
            Activated = activated;
            UpdateState();
        }
        public bool Activated = false;

        [SkipSerialisation]
        public PhysicalBehaviour physical;

        [SkipSerialisation]
        public SpriteRenderer renderer;
        [SkipSerialisation]
        public Sprite A;
        [SkipSerialisation]
        public Sprite B;

        [SkipSerialisation]
        public AudioSource audio;
        [SkipSerialisation]
        public AudioClip audioclip;

        public LightSprite light;
    }
    class PenBehaviour : MonoBehaviour
    {
        private void Start()
        {
            renderer = gameObject.GetComponent<SpriteRenderer>();
            UpdateState();
        }
        void UpdateState()
        {
            if (Activated)
            {
                renderer.sprite = B;
            }
            else
            {
                renderer.sprite = A;
            }
        }
        private void Use()
        {
            if (!base.enabled)
            {
                return;
            }
            if (Activated)
            {
                audio.PlayOneShot(audioclip, 1f);
            }
            else
            {
                audio.PlayOneShot(audioclip, 1f);
            }

            SetActivated(!Activated);
        }
        private void SetActivated(bool activated)
        {
            Activated = activated;
            UpdateState();
        }
        public bool Activated = false;

        [SkipSerialisation]
        public SpriteRenderer renderer;
        [SkipSerialisation]
        public Sprite A;
        [SkipSerialisation]
        public Sprite B;

        [SkipSerialisation]
        public AudioSource audio;
        [SkipSerialisation]
        public AudioClip audioclip;
    }
}

